"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ProteinFeature(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "end",
        "start",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_1_2_0 import opencb as opencb_1_2_0

        return {
            "org.opencb.biodata.models.variant.avro.ProteinFeature": opencb_1_2_0.ProteinFeature,
        }

    __slots__ = [
        "end",
        "start",
        "description",
        "id",
        "type",
    ]

    def __init__(
        self,
        end,
        start,
        description=None,
        id=None,
        type=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_2_0.ProteinFeature model.

        :param end:
        :type end: int
        :param start:
        :type start: int
        :param description:
        :type description: None | str
        :param id:
        :type id: None | str
        :param type:
        :type type: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.0"
